program multiheck_d0

version 8.1
args todo b lnf g negH 

*** STEP 1:  Define the log-likelihood.

	*** Define Beta and Gamma vectors;
	tempvar Ir1 Ir2 Ir3 Ir4 Ir5 Is1 Is2 Is3 Is4 Is5 
	mleval `Ir1'  = `b', eq(1)
	mleval `Is1'  = `b', eq(2)
	mleval `Ir2'  = `b', eq(3)
	mleval `Is2'  = `b', eq(4)
	mleval `Ir3'  = `b', eq(5)
	mleval `Is3'  = `b', eq(6)
	mleval `Ir4'  = `b', eq(7)
	mleval `Is4'  = `b', eq(8)
	mleval `Ir5'  = `b', eq(9)
	mleval `Is5'  = `b', eq(10)
	
	*** Define Sigma matrix;	
	tempname lns1 lns2 lns3 lns4 lns5 sig1 sig2 sig3 sig4 sig5
	mleval `lns1' = `b', scalar eq(11)
	mleval `lns2' = `b', scalar eq(30)
	mleval `lns3' = `b', scalar eq(45)
	mleval `lns4' = `b', scalar eq(56)
	mleval `lns5' = `b', scalar eq(63)
	
	scalar `sig1' = exp(`lns1')
	scalar `sig2' = exp(`lns2')
	scalar `sig3' = exp(`lns3')
	scalar `sig4' = exp(`lns4')
	scalar `sig5' = exp(`lns5')

	*** Define Rhos;
	tempname tau1 tau2 tau3 tau4 tau5 rho1 rho2 rho3 rho4 rho5 dlr dlr2
	mleval `tau1' = `b', scalar eq(12)
	mleval `tau2' = `b', scalar eq(31)
	mleval `tau3' = `b', scalar eq(46)
	mleval `tau4' = `b', scalar eq(57)
	mleval `tau5' = `b', scalar eq(64)
	
      scalar `rho1'  = (exp(2*`tau1')-1)  /  (exp(2*`tau1')+1)
      scalar `rho2'  = (exp(2*`tau2')-1)  /  (exp(2*`tau2')+1)
      scalar `rho3'  = (exp(2*`tau3')-1)  /  (exp(2*`tau3')+1)
      scalar `rho4'  = (exp(2*`tau4')-1)  /  (exp(2*`tau4')+1)
      scalar `rho5'  = (exp(2*`tau5')-1)  /  (exp(2*`tau5')+1)
	
	*** Define Selection Correction Terms;
	tempvar eta1 eta2 eta3 eta4 eta5
	qui gen double `eta1' = (`Is1' +  ($ML_y1 -`Ir1')*`rho1'/`sig1')/sqrt(1-`rho1'^2)
	qui gen double `eta2' = (`Is2' +  ($ML_y3 -`Ir2')*`rho2'/`sig2')/sqrt(1-`rho2'^2)
	qui gen double `eta3' = (`Is3' +  ($ML_y5 -`Ir3')*`rho3'/`sig3')/sqrt(1-`rho3'^2)
	qui gen double `eta4' = (`Is4' +  ($ML_y7 -`Ir4')*`rho4'/`sig4')/sqrt(1-`rho4'^2)
	qui gen double `eta5' = (`Is5' + ($ML_y9 -`Ir5')*`rho5'/`sig5')/sqrt(1-`rho5'^2)

	mlsum `lnf' = cond($ML_y2,(ln(normprob(`eta1')) - 0.5*ln(2*_pi*`sig1'^2) - 0.5*(($ML_y1-`Ir1')/`sig1')^2), ln(normprob(-`Is1'))) //
		//	+ cond($ML_y4,(ln(normprob(`eta2')) - 0.5*ln(2*_pi*`sig2'^2) - 0.5*(($ML_y3-`Ir2')/`sig2')^2), ln(normprob(-`Is2'))) //
		//	+ cond($ML_y6,(ln(normprob(`eta3')) - 0.5*ln(2*_pi*`sig3'^2) - 0.5*(($ML_y5-`Ir3')/`sig3')^2), ln(normprob(-`Is3'))) //
		//	+ cond($ML_y8,(ln(normprob(`eta4')) - 0.5*ln(2*_pi*`sig4'^2) - 0.5*(($ML_y7-`Ir4')/`sig4')^2), ln(normprob(-`Is4'))) //
		//	+ cond($ML_y10,(ln(normprob(`eta5')) - 0.5*ln(2*_pi*`sig5'^2) - 0.5*(($ML_y9-`Ir5')/`sig5')^2), ln(normprob(-`Is5')))

if (`todo'==0 | `lnf' >=.) exit

*** STEP 2:  Define the gradient vector.

end
exit
